/**
 * SplashScreen
 * 启动屏
 * from：http://www.devio.org
 * Author:CrazyCodeBoy
 * GitHub:https://github.com/crazycodeboy
 * Email:crazycodeboy@gmail.com
 */

#import "RNSplashScreen.h"
#import <React/RCTBridge.h>

static bool waiting = true;
static bool addedJsLoadErrorObserver = false;
static UIImageView* loadingView = nil;

@implementation RNSplashScreen
- (dispatch_queue_t)methodQueue{
    return dispatch_get_main_queue();
}
RCT_EXPORT_MODULE(SplashScreen)

+ (void)show {
    if (!addedJsLoadErrorObserver) {
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(jsLoadError:) name:RCTJavaScriptDidFailToLoadNotification object:nil];
        addedJsLoadErrorObserver = true;
    }

    while (waiting) {
        NSDate* later = [NSDate dateWithTimeIntervalSinceNow:0.1];
        [[NSRunLoop mainRunLoop] runUntilDate:later];
    }
}

+ (NSString *)isIphone{
    NSString *isIphone = @"0";
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
        NSLog(@"iPhone dimensions - w: %f, h: %f", [[UIScreen mainScreen] bounds].size.width, [[UIScreen mainScreen] bounds].size.height);
        if ([[UIScreen mainScreen] bounds].size.height == 568 || [[UIScreen mainScreen] bounds].size.width == 568) {
            NSLog(@"iPhone 5");
            
            isIphone = @"2";
        }else{
            NSLog(@" NOT iPhone 5");
            
            if ([[UIScreen mainScreen] bounds].size.height == 667 || [[UIScreen mainScreen] bounds].size.width == 667) {
                NSLog(@"iPhone 6");
                isIphone = @"3";
            }else if([[UIScreen mainScreen] bounds].size.height == 736 || [[UIScreen mainScreen] bounds].size.width == 736){
                NSLog(@"iPhone 6 Plus");
                isIphone = @"4";
            }else if([[UIScreen mainScreen] bounds].size.height == 812 || [[UIScreen mainScreen] bounds].size.width == 812){
                NSLog(@"iPhone X");
                isIphone = @"5";
            }else{
                isIphone = @"1";
            }
        }
    } else {
        NSLog(@"NOT iPhone");
        isIphone = @"0";
    }
    return isIphone;
}

+ (BOOL)isiPhoneSE{
    BOOL isiPhoneSE = NO;
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
        if ([[UIScreen mainScreen] bounds].size.height == 568 || [[UIScreen mainScreen] bounds].size.width == 568) {
            isiPhoneSE = YES;
        }
    }
    return isiPhoneSE;
}

+ (BOOL)isiPhoneRegular{
    BOOL isiPhoneRegular = NO;
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
        if ([[UIScreen mainScreen] bounds].size.height == 667 || [[UIScreen mainScreen] bounds].size.width == 667) {
            isiPhoneRegular = YES;
        }
    }
    return isiPhoneRegular;
}

+ (BOOL)isiPhonePlus{
    BOOL isiPhonePlus = NO;
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
        if ([[UIScreen mainScreen] bounds].size.height == 736 || [[UIScreen mainScreen] bounds].size.width == 736) {
            isiPhonePlus = YES;
        }
    }
    return isiPhonePlus;
}

+ (BOOL)isiPhoneX{
    BOOL isiPhoneX = NO;
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
        if ([[UIScreen mainScreen] bounds].size.height == 812 || [[UIScreen mainScreen] bounds].size.width == 812) {
            isiPhoneX = YES;
        }
    }
    return isiPhoneX;
}

+ (BOOL)isiPhoneXr{
    BOOL isiPhoneXr = NO;
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
        if ([[UIScreen mainScreen] bounds].size.height == 896 || [[UIScreen mainScreen] bounds].size.width == 896) {
            if ([[UIScreen mainScreen] respondsToSelector:@selector(scale)] && [[UIScreen mainScreen] scale] == 2.0){
                isiPhoneXr = YES;
            }
        }
    }
    return isiPhoneXr;
}

+ (BOOL)isiPhoneXSMax{
    BOOL isiPhoneXSMax = NO;
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
        if ([[UIScreen mainScreen] bounds].size.height == 896 || [[UIScreen mainScreen] bounds].size.width == 896) {
            if ([[UIScreen mainScreen] respondsToSelector:@selector(scale)] && [[UIScreen mainScreen] scale] == 3.0){
                isiPhoneXSMax = YES;
            }
        }
    }
    return isiPhoneXSMax;
}

+ (BOOL)isiPadRegular{
    BOOL isiPad = NO;
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad){
        if ([[UIScreen mainScreen] bounds].size.height == 1024 || [[UIScreen mainScreen] bounds].size.width == 1024) {
            isiPad = YES;
        }
    }
    return isiPad;
}

+ (BOOL)isiPadPro10dot5{
    BOOL isPro = NO;
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad){
        if ([[UIScreen mainScreen] bounds].size.height == 1112 || [[UIScreen mainScreen] bounds].size.width == 1112) {
            isPro = YES;
        }
    }
    return isPro;
}

+ (BOOL)isIPadPro11{
    BOOL isPro = NO;
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad){
        if ([[UIScreen mainScreen] bounds].size.height == 1194 || [[UIScreen mainScreen] bounds].size.width == 1194) {
            isPro = YES;
        }
    }
    return isPro;
}

+ (BOOL)isIPadPro12dot9{
    BOOL isPro = NO;
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad){
        if ([[UIScreen mainScreen] bounds].size.height == 1366 || [[UIScreen mainScreen] bounds].size.width == 1366) {
            isPro = YES;
        }
    }
    return isPro;
}

- (BOOL)isRetina{
    BOOL isRetina = NO;
    if ([[UIScreen mainScreen] respondsToSelector:@selector(scale)] && [[UIScreen mainScreen] scale] >= 2.0){
        isRetina = YES;
    }
    return isRetina;
}

+ (UIImage *)getStartupImage {
    UIInterfaceOrientation orientation = [[UIApplication sharedApplication] statusBarOrientation];
    UIImage *startUpImageFromFile = nil;
    
    if(orientation == UIInterfaceOrientationLandscapeRight || orientation ==  UIInterfaceOrientationLandscapeLeft){
            if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
                if ([self isIPadPro12dot9]) {
                    startUpImageFromFile = [UIImage imageNamed:@"Default-Landscape-1024w-1366h"];
                } else if ([self isIPadPro11]) {
                    startUpImageFromFile = [UIImage imageNamed:@"Default-Landscape-1194h"];
                } else if ([self isiPadPro10dot5]) {
                    startUpImageFromFile = [UIImage imageNamed:@"Default-Landscape-834w-1112h"];
                } else {
                    startUpImageFromFile = [UIImage imageNamed:@"Default-Landscape"];
                }
            }else{
                if ([self isiPhoneXSMax]) {
                    startUpImageFromFile = [UIImage imageNamed:@"Default-Landscape-1242h"];
                } else if ([self isiPhoneXr]) {
                    startUpImageFromFile = [UIImage imageNamed:@"Default-Landscape-896h"];
                } else if ([self isiPhoneX]) {
                    startUpImageFromFile = [UIImage imageNamed:@"Default-Landscape-812h"];
                } else if ([self isiPhonePlus]) {
                    startUpImageFromFile = [UIImage imageNamed:@"Default-Landscape-414w-736h"];
                } else {
                    //for devices without landscape image
                    if ([self isiPhoneRegular]) {
                       startUpImageFromFile = [UIImage imageNamed:@"Default-667h"];
                    } else {
                        startUpImageFromFile = [UIImage imageNamed:@"Default-568h"];
                    }
                    
                    UIImageOrientation imageOrientation = UIImageOrientationLeft;
                    if (orientation == UIInterfaceOrientationLandscapeLeft) {
                        imageOrientation = UIImageOrientationRight;
                    }
                    //rotate the image
                    startUpImageFromFile = [[UIImage alloc] initWithCGImage: startUpImageFromFile.CGImage
                                                                         scale: 1.0
                                                                   orientation: imageOrientation];
                }
            }
    }else{
        if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
            if ([self isIPadPro12dot9]) {
                startUpImageFromFile = [UIImage imageNamed:@"Default-Portrait-1024w-1366h"];
            } else if ([self isIPadPro11]) {
                startUpImageFromFile = [UIImage imageNamed:@"Default-Portrait-1194h"];
            } else if ([self isiPadPro10dot5]) {
                startUpImageFromFile = [UIImage imageNamed:@"Default-Portrait-834w-1112h"];
            } else {
                startUpImageFromFile = [UIImage imageNamed:@"Default-Portrait"];
            }
        }else{
            if ([self isiPhoneXSMax]) {
                startUpImageFromFile = [UIImage imageNamed:@"Default-1242h"];
            } else if ([self isiPhoneXr]) {
                startUpImageFromFile = [UIImage imageNamed:@"Default-896h"];
            } else if ([self isiPhoneX]) {
                startUpImageFromFile = [UIImage imageNamed:@"Default-375h-812h"];
            } else if ([self isiPhonePlus]) {
                startUpImageFromFile = [UIImage imageNamed:@"Default-736h"];
            } else if ([self isiPhoneRegular]) {
                startUpImageFromFile = [UIImage imageNamed:@"Default-667h"];
            } else {
                startUpImageFromFile = [UIImage imageNamed:@"Default-568h"];
            }
        }
    }
    
    return startUpImageFromFile;
    
}

+ (void)showSplashInRootView:(UIView*)rootView {
    if (!loadingView) {
        loadingView = [[UIImageView alloc] initWithFrame:[UIScreen mainScreen].bounds];
        UIImage *splashImage = [self getStartupImage];
        if (splashImage) {
            [loadingView setImage:splashImage];
        }
    }
    waiting = false;
    
    [rootView addSubview:loadingView];
}

+ (void)hide {
    if (waiting) {
        dispatch_async(dispatch_get_main_queue(), ^{
            waiting = false;
        });
    } else {
        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
            [loadingView removeFromSuperview];
        });
    }
}

+ (void) jsLoadError:(NSNotification*)notification
{
    // If there was an error loading javascript, hide the splash screen so it can be shown.  Otherwise the splash screen will remain forever, which is a hassle to debug.
    [RNSplashScreen hide];
}

RCT_EXPORT_METHOD(hide) {
    [RNSplashScreen hide];
}

RCT_EXPORT_METHOD(show) {
    [RNSplashScreen show];
}

@end
